#! /bin/sh

# --------------------------------------------------------------------------
#  DIVA CONFIGURATION WIZARD
#  Copyright by Eicon Networks 1993-2000
# --------------------------------------------------------------------------

# -----------------------------------------------------
# SERVER CARD PnP ID
# -----------------------------------------------------
server_pnp_id_0=e014
server_pnp_id_1=e015
server_pnp_id_2=e019
server_pnp_id_3=e012
server_pnp_id_4=e016
server_pnp_id_5=e010
server_pnp_id_6=e013
server_pnp_id_7=e017
server_pnp_id_8=e018
server_pnp_id_9=e01a
server_pnp_id_a=e01b

# -----------------------------------------------------
# PASSIVE CARD PnP ID
# -----------------------------------------------------
passive_pnp_id_0=e006
passive_card_names_0="DIVA CT S/T PCI"
passive_pnp_id_1=e001
passive_card_names_1="DIVA PRO 2.0 S/T PCI"
passive_pnp_id_2=e005
passive_card_names_2="DIVA PCI 2.01 S/T"
passive_pnp_id_3=e00b
passive_card_names_3="DIVA PCI 2.02 S/T"
passive_pnp_id_4=e00d
passive_card_names_4="Diva Pro 3.0 PCI"
passive_pnp_id_5=e00e
passive_card_names_5="DIVA ISDN + CT 2.0"

# -----------------------------------------------------
# PC CARD PnP ID
# -----------------------------------------------------
pcm_pro_pnp_id="pro_pcm"
pcm_pro_card_name="DIVA Pro PC-Card"
pcm_isdn_v2_pnp_id="isdn_pcm"
pcm_isdn_v2_card_name="Diva ISDN PC Card"
pcm_mobile_v2_pnp_id="mobile_pcm"
pcm_mobile_v2_card_name="Diva Mobile V.90 PC Card"

# -----------------------------------------------------
# CONSTANTS
# -----------------------------------------------------
eicon_proc=/proc/net/eicon
pci_dtb=/proc/bus/pci/devices
divas4linux=0
if [ -f /usr/lib/eicon/divas/divadidd.o ]
then
divas4linux=1
diva_dir=/usr/lib/eicon/divas
divaload="$diva_dir/divactrl load"
driver_path="$diva_dir/"
else
diva_dir=/usr/share/eicon
divaload="/sbin/divactrl load"
driver_path=" "
fi
manufacturer=1133
cfg_file=divas_cfg.rc
config=$diva_dir/$cfg_file
diva_log=/var/log/diva
diva_tty_major=8

if [ -f $diva_dir/divas.o ]
then
  do_detect_server_cards=1
else
  do_detect_server_cards=1
fi
# -----------------------------------------------------
#  PCMCIA VARIABLES
# -----------------------------------------------------
diva_pcmcia_present=0
diva_pc_card=0
if [ -f $diva_dir/diva_cs.o ]
then
  if [ -f $diva_dir/DivasC.o ]
  then
    diva_pcmcia_present=1
    diva_pc_card=257
  fi
fi
diva_lib_modules_path=/lib/modules/$(uname -r)

# -----------------------------------------------------
# VARIABLES
# -----------------------------------------------------
server_card_count=0
passive_card_id=0
passive_card_name="none"
passive_card_found=0
xdi_was_loaded=0
diva_errno=0
current=0
current_card=0
logical_card=0
current_card_type="none"
logical_cards=0
b_channels=0
current_card_adapters=0
current_logic_adapter=0
do_configuration=2
view_configuration=2
logical_adapter_to_configure=0
diva_uses_separate_configuration=0
group_optimization_cards=0
group_optimization_card=0
global_fax_class_2_options=0

# -----------------------------------------------------
# ASK if user uses same configuration for all
# logical adapters of 4BRI card
# -----------------------------------------------------
diva_ask_for_separate_configuration()
{
diva_uses_separate_configuration=2

while [ $((diva_uses_separate_configuration)) -eq 2 ]
do
clear
echo ' -------------------------------------------------------------------------------'
echo "     DO YOU WISH TO USE A DIFFERENT CONFIGURATION FOR EACH PORT OF THE"
echo "     '$current_card_type' ADAPTER WITH SERIAL NUMBER '$current_card_sn'?"
echo ' -------------------------------------------------------------------------------'
echo '       --+'
echo '         +---------------------------------------------------------+'
echo '         +-------------+                                           |'
echo '         # ISDN PORT 1 |                                           |'
echo '         +-------------+                                           |'
echo '         +-------------+                                           |'
echo '         # ISDN PORT 2 |                                           |'
echo '         +-------------+                                           |'
echo '         +-------------+                                           |'
echo '         # ISDN PORT 3 |                                           |'
echo '         +-------------+                                           |'
echo '         +-------------+                                           |'
echo '         # ISDN PORT 4 |                                           |'
echo '         +-------------+                                           |'
echo '         +---------------------------------------------------------+'
echo '         |            |       PCI BUS    ||   |'
echo '         |            +------------------++---+'
echo ""
echo ' -------------------------------------------------------------------------------'
echo -e "Your selection (Y/N)[N]: \c"
read diva_uses_separate_configuration
if [ -z $diva_uses_separate_configuration ]
then
diva_uses_separate_configuration="N"
fi
case $diva_uses_separate_configuration in

  Y) diva_uses_separate_configuration=1
   ;;

  y) diva_uses_separate_configuration=1
   ;;

  N) diva_uses_separate_configuration=0
   ;;

  n) diva_uses_separate_configuration=0
   ;;

  *) diva_uses_separate_configuration=2
   ;;

esac

done
}


# ----------------------------------------------------------------------------
#  FAX CLASS 2 OPTIONS
# ----------------------------------------------------------------------------
diva_global_fax_options()
{
global_fax_class_2_options=255
while [ $((global_fax_class_2_options)) -eq 255 ]
do

clear
echo ' -------------------------------------------------------------------------------'
echo '                PLEASE SELECT FAX CLASS 2 OPTIONS'
echo ' -------------------------------------------------------------------------------'
echo " 0 - Use application provided values"
echo " 1 - Force ECM for FAX CLASS 2"
echo " 2 - Force V.34 (33600 + ECM) for FAX CLASS 2 (default)"
echo ' -------------------------------------------------------------------------------'
echo -e "Your selection [2]: \c"
read global_fax_class_2_options
if [ -z $global_fax_class_2_options ]
then
global_fax_class_2_options=2
fi
case $global_fax_class_2_options in
	0) global_fax_class_2_options=0
		;;
	1) global_fax_class_2_options=1
		;;
	2) global_fax_class_2_options=3
		;;
	*) global_fax_class_2_options=255
		;;
esac

done
}

# ----------------------------------------------------------------------------
#  CAPI GROUP OPTIMIZATION
# ----------------------------------------------------------------------------
diva_group_optimization_options()
{
capi_group_optimization=255
while [ $((capi_group_optimization)) -eq 255 ]
do
clear
echo ' -------------------------------------------------------------------------------'
echo "       DO YOU WISH TO TURN CAPI 'GROUP OPTIMIZATION' ON THIS ADAPTER 'ON' ?"
echo ' -------------------------------------------------------------------------------'
echo -e "Your selection (Y/N)[N]: \c"
read capi_group_optimization
if [ -z $capi_group_optimization ]
then
capi_group_optimization="N"
fi
case $capi_group_optimization in
  Y) capi_group_optimization=1
   ;;
  y) capi_group_optimization=1
   ;;
  N) capi_group_optimization=0
   ;;
  n) capi_group_optimization=0
   ;;
  *) capi_group_optimization=255
esac
done
if [ $((capi_group_optimization)) -eq 1 ]
then
  while [ $((group_optimization_cards)) -ge 1 ]
  do
  echo "echo 1 > $eicon_proc/adapter$((group_optimization_card))/group_optimization" >> $diva_dir/diva_capi_group_optimization_file
  group_optimization_cards=$(($group_optimization_cards-1))
  group_optimization_card=$(($group_optimization_card+1))
  done
fi
}

# -----------------------------------------------------
# CREATE DEVICE NODES
# -----------------------------------------------------
create_interface_nodes()
{
want_ttys=$((b_channels))

rm -f $diva_lib_modules_path/diva/diva_cs.o
rm -f $diva_lib_modules_path/diva/divadidd.o

# Values for $diva_pc_card from 1...9 are reserved for PCMCIA cards
if [ $((diva_pc_card)) -ge 1 ] && [ $((diva_pc_card)) -le 9 ]
then
  clear
  echo""
  mkdir -m 755 $diva_lib_modules_path/diva > /dev/null 2>&1
  ln -s $diva_dir/diva_cs.o  $diva_lib_modules_path/diva/diva_cs.o
  ln -s $diva_dir/divadidd.o $diva_lib_modules_path/diva/divadidd.o
	if [ -f $diva_lib_modules_path/kernel/drivers/isdn/eicon/divas.o -o -f $diva_lib_modules_path/kernel/drivers/isdn/eicon/eicon.o ]
  then
  renamed_module_name="_kernel_drivers_isdn_eicon_divas.o"
  renamed2_module_name="_kernel_drivers_isdn_eicon_eicon.o"
echo ' -------------------------------------------------------------------------------'
echo "              RENAMED OBSOLETE DIVA SERVER MODULES"
echo " "
if [ -f $diva_lib_modules_path/kernel/drivers/isdn/eicon/divas.o ]
then
echo "     '$diva_lib_modules_path/kernel/drivers/isdn/eicon/divas.o'"
echo "       to"
echo "     '$diva_lib_modules_path$renamed_module_name'"
echo " "
fi
if [ -f $diva_lib_modules_path/kernel/drivers/isdn/eicon/eicon.o ]
then
echo "     '$diva_lib_modules_path/kernel/drivers/isdn/eicon/eicon.o'"
echo "       to"
echo "     '$diva_lib_modules_path$renamed2_module_name'"
fi
echo ' -------------------------------------------------------------------------------'
	if [ -f $diva_lib_modules_path/kernel/drivers/isdn/eicon/divas.o ]
  then
	  chmod -f u+w $diva_lib_modules_path/kernel/drivers/isdn/eicon/divas.o \
                 $diva_lib_modules_path$renamed_module_name
	  rm -f $diva_lib_modules_path$renamed_module_name
	  mv -f $diva_lib_modules_path/kernel/drivers/isdn/eicon/divas.o  \
          $diva_lib_modules_path$renamed_module_name
  fi
	if [ -f $diva_lib_modules_path/kernel/drivers/isdn/eicon/eicon.o ]
  then
	  chmod -f u+w $diva_lib_modules_path/kernel/drivers/isdn/eicon/eicon.o \
	               $diva_lib_modules_path$rename2_module_name
	  rm -f $diva_lib_modules_path$renamed2_module_name
	  mv -f $diva_lib_modules_path/kernel/drivers/isdn/eicon/eicon.o  \
          $diva_lib_modules_path$renamed2_module_name
  fi
  echo "  Please press ENTER to continue ..."
	read -t 20 unused_input
  clear
  echo""
  fi
echo ' -------------------------------------------------------------------------------'
echo "     Execute 'depmod -a' ..."
echo ' -------------------------------------------------------------------------------'
  depmod -a -q > /dev/null 2>&1
  if [ -d /etc/pcmcia ]
  then
    rm -f /etc/pcmcia/diva.conf
    cp $diva_dir/diva.conf /etc/pcmcia/diva.conf
  fi
	if [ -x /etc/rc.d/pcmcia ]
  then
    /etc/rc.d/pcmcia stop
		sleep 2
    /etc/rc.d/pcmcia start
  else
    if [ -x /etc/rc.d/init.d/pcmcia ]
    then
      /etc/rc.d/init.d/pcmcia stop
			sleep 2
      /etc/rc.d/init.d/pcmcia start
    else
  if [ -f /var/run/cardmgr.pid ]
  then
    kill -HUP $(cat /var/run/cardmgr.pid)
  fi
fi
  fi
fi

#
# Fix changed done by older versions of driver
#
rm -f /dev/Divas
rm -f /dev/DivasI*
rm -f /dev/capi20
mknod /dev/capi20 c 68 0

#
# Create device nodes for TTY interface
#
if [ -f $diva_dir/Divatty.o ]
then
  mknod /dev/ttydsctrl c $((diva_tty_major)) 0

  if [ $((want_ttys)) -ge 10 ]
  then
    while [ $((want_ttys)) != 9 ]
    do
      mknod /dev/ttyds$((want_ttys)) c $((diva_tty_major)) $((want_ttys))
      want_ttys=$want_ttys-1
    done
  fi

  while [ $((want_ttys)) != 0 ]
  do
    mknod /dev/ttyds0$((want_ttys)) c $((diva_tty_major)) $((want_ttys))
    want_ttys=$want_ttys-1
  done
fi
}

# -----------------------------------------------------
# LOAD/UNLOAD XDI DRIVER
# -----------------------------------------------------
load_xdi_driver()
{
sync
if [ -f $eicon_proc/divas ]
then
  xdi_was_loaded=1
  diva_errno=0
  return
else
  xdi_was_loaded=0
  if [ $((divas4linux)) -eq 1 ]
  then
    if [ ! -f $eicon_proc/divadidd ]
    then
      insmod -f ${driver_path}divadidd.o
    fi
    insmod -f ${driver_path}divas.o
  else
    modprobe divas
  fi
fi

if [ -f $eicon_proc/divas ]
then
diva_errno=0
else
diva_errno=1
$diva_dir/divas_stop.rc
fi
}

unload_xdi_driver()
{
sync
if [ $((xdi_was_loaded)) -eq 0 ]
then
$diva_dir/divas_stop.rc
fi
}

# -----------------------------------------------------
# EXIT IN CASE NO CARDS WAS FOUND
# -----------------------------------------------------
diva_exit_no_cards()
{
clear
echo ' -------------------------------------------------------------------------------'
echo '     DIVA CONFIGURATION ABORTED: NO DIVA CARDS FOUND'
echo ' -------------------------------------------------------------------------------'
echo
exit 1
}

# -----------------------------------------------------
# PASSIVE CARD DETECTION ROUTINE
# -----------------------------------------------------
detect_passive_card()
{
if [ -f $diva_dir/DivasC.o ]
then
  current_card="none"
else
  return
fi

# TYPE 0
current_card_id=$passive_pnp_id_0
passive_card_id=$current_card_id
passive_card_name=$passive_card_names_0
current_card=$manufacturer$current_card_id
passive_card_found=$(($(cat $pci_dtb | cut -f 2 -d" " | \
                                           grep $current_card | wc -l)))
if [ $(($passive_card_found)) -ne 0 ]
then
passive_card_found=1
return
fi

# TYPE 1
current_card_id=$passive_pnp_id_1
passive_card_id=$current_card_id
passive_card_name=$passive_card_names_1
current_card=$manufacturer$current_card_id
passive_card_found=$(($(cat $pci_dtb | cut -f 2 -d" " | \
                                           grep $current_card | wc -l)))
if [ $(($passive_card_found)) -ne 0 ]
then
passive_card_found=1
return
fi

# TYPE 2
current_card_id=$passive_pnp_id_2
passive_card_id=$current_card_id
passive_card_name=$passive_card_names_2
current_card=$manufacturer$current_card_id
passive_card_found=$(($(cat $pci_dtb | cut -f 2 -d" " | \
                                           grep $current_card | wc -l)))
if [ $(($passive_card_found)) -ne 0 ]
then
passive_card_found=1
return
fi

# TYPE 3
current_card_id=$passive_pnp_id_3
passive_card_id=$current_card_id
passive_card_name=$passive_card_names_3
current_card=$manufacturer$current_card_id
passive_card_found=$(($(cat $pci_dtb | cut -f 2 -d" " | \
                                           grep $current_card | wc -l)))
if [ $(($passive_card_found)) -ne 0 ]
then
passive_card_found=1
return
fi

# TYPE 4
current_card_id=$passive_pnp_id_4
passive_card_id=$current_card_id
passive_card_name=$passive_card_names_4
current_card=$manufacturer$current_card_id
passive_card_found=$(($(cat $pci_dtb | cut -f 2 -d" " | \
                                           grep $current_card | wc -l)))
if [ $(($passive_card_found)) -ne 0 ]
then
passive_card_found=1
return
fi

# TYPE 5
current_card_id=$passive_pnp_id_5
passive_card_id=$current_card_id
passive_card_name=$passive_card_names_5
current_card=$manufacturer$current_card_id
passive_card_found=$(($(cat $pci_dtb | cut -f 2 -d" " | \
                                           grep $current_card | wc -l)))
if [ $(($passive_card_found)) -ne 0 ]
then
passive_card_found=1
return
fi
}

# -----------------------------------------------------
# SERVER CARD DETECTION ROUTINE
# -----------------------------------------------------
detect_server_cards()
{
if [ $((do_detect_server_cards)) -eq 0 ]
then
  return
fi

# TYPE 0
current_card_id=$server_pnp_id_0
current_card=$manufacturer$current_card_id
server_card_count=$(($server_card_count+ \
               $(cat $pci_dtb | cut -f 2 -d" " | grep $current_card | wc -l)))

# TYPE 1
current_card_id=$server_pnp_id_1
current_card=$manufacturer$current_card_id
server_card_count=$(($server_card_count+ \
               $(cat $pci_dtb | cut -f 2 -d" " | grep $current_card | wc -l)))

# TYPE 2
current_card_id=$server_pnp_id_2
current_card=$manufacturer$current_card_id
server_card_count=$(($server_card_count+ \
               $(cat $pci_dtb | cut -f 2 -d" " | grep $current_card | wc -l)))



# TYPE 3
current_card_id=$server_pnp_id_3
current_card=$manufacturer$current_card_id
server_card_count=$(($server_card_count+ \
               $(cat $pci_dtb | cut -f 2 -d" " | grep $current_card | wc -l)))

# TYPE 4
current_card_id=$server_pnp_id_4
current_card=$manufacturer$current_card_id
server_card_count=$(($server_card_count+ \
               $(cat $pci_dtb | cut -f 2 -d" " | grep $current_card | wc -l)))

# TYPE 5
current_card_id=$server_pnp_id_5
current_card=$manufacturer$current_card_id
server_card_count=$(($server_card_count+ \
               $(cat $pci_dtb | cut -f 2 -d" " | grep $current_card | wc -l)))

# TYPE 6
current_card_id=$server_pnp_id_6
current_card=$manufacturer$current_card_id
server_card_count=$(($server_card_count+ \
               $(cat $pci_dtb | cut -f 2 -d" " | grep $current_card | wc -l)))

# TYPE 7
current_card_id=$server_pnp_id_7
current_card=$manufacturer$current_card_id
server_card_count=$(($server_card_count+ \
               $(cat $pci_dtb | cut -f 2 -d" " | grep $current_card | wc -l)))

# TYPE 8
current_card_id=$server_pnp_id_8
current_card=$manufacturer$current_card_id
server_card_count=$(($server_card_count+ \
               $(cat $pci_dtb | cut -f 2 -d" " | grep $current_card | wc -l)))

# TYPE 9
current_card_id=$server_pnp_id_9
current_card=$manufacturer$current_card_id
server_card_count=$(($server_card_count+ \
               $(cat $pci_dtb | cut -f 2 -d" " | grep $current_card | wc -l)))

# TYPE A
current_card_id=$server_pnp_id_a
current_card=$manufacturer$current_card_id
server_card_count=$(($server_card_count+ \
               $(cat $pci_dtb | cut -f 2 -d" " | grep $current_card | wc -l)))

}

# ------------------------------------------------------------------------
#  MAIN
# ------------------------------------------------------------------------
if [ $UID != 0 ]
then
clear
echo ' -------------------------------------------------------------------------------'
echo '  DIVA CONFIGURATION ABORTED: ONLY ROOT CAN EXECUTE THIS SCRIPT'
echo ' -------------------------------------------------------------------------------'
echo
exit 1
fi

sync

# ------------------------------------------------------------------------
#  DETECT CARDS
# ------------------------------------------------------------------------
detect_server_cards
detect_passive_card

# ------------------------------------------------------------------------
#  START CONFIGURATION
# ------------------------------------------------------------------------
if [ $(($server_card_count+$passive_card_found)) -eq 0 ]
then
  if [ $((diva_pcmcia_present)) -eq 1 ]
  then
    while [ $((diva_pc_card)) -eq 257 ]
    do
      clear
echo ' -------------------------------------------------------------------------------'
echo '                    DIVA ISDN ADAPTER CONFIGURATION WIZARD'
echo '                                     ---'
echo '                     Copyright Eicon Networks 1991-2000'
echo '                                     ---'
echo '                             No DIVA cards found.'
echo '                                     ---'
echo '                    Please select one from the list below:'
echo '                    0 - none of the following cards'
echo "                    1 - $pcm_pro_card_name"
echo "                    2 - $pcm_isdn_v2_card_name"
#echo "                    3 - $pcm_mobile_v2_card_name"
echo ' -------------------------------------------------------------------------------'
      echo -e "Your selection [1]: \c"
      read diva_pc_card
      if [ -z $diva_pc_card ]
      then
        diva_pc_card=1
      fi
    done
    if [ $((diva_pc_card)) -eq 0 ]
    then
      diva_exit_no_cards
    fi
  else
    diva_exit_no_cards
  fi
fi


# ------------------------------------------------------------------------
#  In case of pcmcia card we have to set the data and
#  need not ask if user wishes to configure the card - this question
#  was already answered
#  Values for $diva_pc_card from 1...9 are reserved for PCMCIA cards
# ------------------------------------------------------------------------
case $diva_pc_card in
 1) do_configuration=1
		passive_card_found=1
		passive_card_id=$pcm_pro_pnp_id
		passive_card_name=$pcm_pro_card_name
  ;;
 2) do_configuration=1
		passive_card_found=1
		passive_card_id=$pcm_isdn_v2_pnp_id
		passive_card_name=$pcm_isdn_v2_card_name
  ;;
# 3) do_configuration=1
#		passive_card_found=1
#		passive_card_id=$pcm_mobile_v2_pnp_id
#		passive_card_name=$pcm_mobile_v2_card_name
#  ;;
esac

# ------------------------------------------------------------------------
#  ASK FOR CONFIGURATION
# ------------------------------------------------------------------------
while [ $do_configuration -eq $((2)) ]
do
clear
echo ' -------------------------------------------------------------------------------'
echo '                    DIVA ISDN ADAPTER CONFIGURATION WIZARD'
echo '                                     ---'
echo '                     Copyright Eicon Networks 1991-2000'
echo '                                     ---'
if [ $(($server_card_count+$passive_card_found)) -eq 1 ]
then
echo '                            1 DIVA ADAPTER  FOUND'
else
echo "                            $(($server_card_count+$passive_card_found)) DIVA ADAPTERS FOUND"
fi
echo ' -------------------------------------------------------------------------------'
echo -e " Start Configuration (Y/N)[Y]: \c"
read do_configuration
if [ -z $do_configuration ]
then
do_configuration="Y"
fi
case $do_configuration in
 Y) do_configuration=1
  ;;
 y) do_configuration=1
  ;;
 N) do_configuration=0
  ;;
 n) do_configuration=0
  ;;
 *) do_configuration=2
  ;;
esac

if [ $do_configuration -eq 0 ]
then
clear
echo ' -------------------------------------------------------------------------------'
echo '                  DIVA ISDN ADAPTER CONFIGURATION ABORTED'
echo ' -------------------------------------------------------------------------------'
echo
exit 2
fi
done

# ------------------------------------------------------------------------
#  Load XDI module
# ------------------------------------------------------------------------
if [ $((server_card_count)) -ge 1 ]
then
load_xdi_driver
else
diva_errno=0
fi
if [ $((diva_errno)) -ne 0 ]
then
clear
echo ' -------------------------------------------------------------------------------'
echo "  DIVA CONFIGURATION ABORTED: CAN'T LOAD XDI DRIVER"
echo ' -------------------------------------------------------------------------------'
echo
rm -f $config
exit 1
fi

#
# Remove old config file and old device nodes
#
rm -f $config
rm -f /dev/ttyds*

# ---------------------------------------------------------------------------
#  Create config file header and all necessary subroutines
# ---------------------------------------------------------------------------
echo '#! /bin/sh'    >  $config
echo "# ----------------------------------------------------------------------" >> $config
echo "#  CONFIGURATION SCRIPT FOR EICON DIVA ISDN ADAPTERS" >> $config
echo "#  THIS SCRIPT WAS GENERATED AUTOMATICALLY BY"        >> $config
echo "#  $diva_dir/divas_cfg.sh"                            >> $config
echo "#"                                                    >> $config
echo "#  Copyright 1993-2001 by Eicon Networks"             >> $config
echo "# ----------------------------------------------------------------------" >> $config
echo ""                                                     >> $config
echo 'card_count=0'                                         >> $config
echo 'current_card_type="none"'                             >> $config
echo 'current_card_sn="none"'                               >> $config
echo ""                                                     >> $config

echo 'diva_print_abort()'                                   >> $config
echo '{'                                                    >> $config
echo "echo ' -------------------------------------------------------------------------------'" >> $config
echo "echo '  DIVA CONFIGURATION ABORTED: HARDWARE CONFIGURATION CHANGED'" >> $config
echo "echo '                              PLEASE START DIVA CONFIGURATION WIZARD'" >> $config
echo "echo '                              ($diva_dir/cfg_divas.sh)'" >> $config
echo "echo ' -------------------------------------------------------------------------------'" >> $config
echo '}'                                                    >> $config
echo ""

diva_print_unknown_card()
{
clear
echo ' -------------------------------------------------------------------------------'
echo "  DIVA CONFIGURATION ABORTED: UNKNOWN CARD - '$current_card_type'"
echo '                              PLEASE UPDATE DIVA CONFIGURATION WIZARD'
echo '                              ($diva_dir/cfg_divas.sh)'
echo ' -------------------------------------------------------------------------------'
}

echo "if [ ! -f $eicon_proc/divas ]"                        >> $config
echo 'then'                                                 >> $config
echo "echo -e \"Load DIVA XDI driver ... \c\""              >> $config
if [ $((divas4linux)) -eq 1 ]
then
  echo "if [ ! -f $eicon_proc/divadidd ]"                   >> $config
  echo 'then'                                               >> $config
  echo "insmod -f ${driver_path}divadidd.o"                 >> $config
  echo 'fi'                                                 >> $config
  if [ $((server_card_count)) -ge 1 ]
  then
    echo "insmod -f ${driver_path}divas.o"                    >> $config
  fi
else
  if [ $((server_card_count)) -ge 1 ]
  then
    echo "modprobe divas"                                     >> $config
  fi
fi
echo 'echo OK'                                              >> $config
echo 'else'                                                 >> $config
echo "echo ' -------------------------------------------------------------------------------'" >> $config
echo "echo '  DIVA CONFIGURATION ABORTED: DRIVERS HAS BEEN ALREADY LOADED'" >> $config
echo "echo '                              PLEASE STOP FIRST BY'"      >> $config
echo "echo '                              $diva_dir/divas_stop.rc'" >> $config
echo "echo ' -------------------------------------------------------------------------------'" >> $config
echo 'exit 1'                                               >> $config
echo 'fi'                                                   >> $config
echo ""                                                     >> $config

# 
# Load user mode IDI driver
#
echo "echo -e \"Load DIVA User Mode IDI driver ... \c\""   >> $config
if [ $((divas4linux)) -eq 1 ]
then
  echo "insmod -f ${driver_path}diva_idi.o"                 >> $config
else
  echo "modprobe diva_idi"                                  >> $config
fi
echo 'echo OK'                                              >> $config
echo ""

# Remove older XLOG files
echo 'rm -f /var/log/diva*.log'                             >> $config

# ----------------------------------------------------------------------------
#  Configure all found server cards
#
#  BRI:
#  ./cfg_bri.sh
#    parameters:
#               1: physical_card_number
#               2: install_dir
#               3: b_channels
#               4: passive/active
#               5: card_name
#               6: ident
#               7: logical_card_number
#               8: logical adapter number
#               9: BRI revision 1 adapter
#              10: Supports NT mode
#
#  PRI:
#  ./cfg_pri.sh
#
#
#
# ----------------------------------------------------------------------------

rm -f $diva_dir/diva_capi_group_optimization_file
rm -f $diva_dir/diva_capi_dynamic_l1_file

echo "" >> $config
current_card=1
logical_card=1
while [ $((current_card)) -le $(($server_card_count)) ]
do
current_card_type=$($divaload -c $logical_card -CardName)
current_card_sn=$($divaload -c $logical_card -SerialNumber)
current_card_type_lk=$(echo $current_card_type | tr [A-Z] [a-z])

echo "#  $current_card_type SN:$current_card_sn"           >> $config
echo -n 'current_card_type=$('                             >> $config
echo -n $divaload -c $logical_card -CardName               >> $config
echo ')'                                                   >> $config
echo -n 'current_card_sn=$('                               >> $config
echo -n $divaload -c $logical_card -SerialNumber           >> $config
echo ')'                                                   >> $config
echo 'current_card_type=$(echo $current_card_type | tr [A-Z] [a-z])' >> $config
echo 'current_card_type="$current_card_type $current_card_sn"' >> $config
echo 'case $current_card_type in'                          >> $config
echo "   '$current_card_type_lk $current_card_sn')"        >> $config
echo '                      card_count=$(($card_count+1))' >> $config
echo "                      ;;"                            >> $config
echo ""                                                    >> $config
echo '                    *)'                              >> $config
echo "                      diva_print_abort"              >> $config
echo "                      $diva_dir/divas_stop.rc"       >> $config
echo '                      exit 1'                        >> $config
echo "                      ;;"                            >> $config
echo esac                                                  >> $config


current_card_adapters=1
current_logic_adapter=$((logical_card))

case $current_card_type_lk in
  'diva server 4bri-8m 2.0 pci')
    cfg_cmd="sh $diva_dir/cfg_bri.sh $((current_card)) $diva_dir 8 0"
    diva_ask_for_separate_configuration
    if [ $((diva_uses_separate_configuration)) -eq 0 ]
    then
      $cfg_cmd "$current_card_type SN:$current_card_sn" 0 $((logical_card)) \
                                                                  0 0 1
      group_optimization_cards=4
      group_optimization_card=$((logical_card))
      diva_group_optimization_options
    else
      logical_adapter_to_configure=1
      while [ $((logical_adapter_to_configure)) -le 4 ]
      do
        $cfg_cmd "$current_card_type SN:$current_card_sn" 0 $((logical_card)) \
                                        $((logical_adapter_to_configure)) 0 1
        group_optimization_cards=1
        group_optimization_card=$(($logical_card+$logical_adapter_to_configure-1))
        diva_group_optimization_options
        logical_adapter_to_configure=$(($logical_adapter_to_configure+1))
      done
      echo "" >> $config
    fi
    logical_cards=$(($logical_cards+4))
    b_channels=$(($b_channels+8))
    logical_card=$(($logical_card+4))
    current_card_adapters=4
  ;;

  'diva server voice 4bri-8m 2.0 pci')
    cfg_cmd="sh $diva_dir/cfg_bri.sh $((current_card)) $diva_dir 8 0"
    diva_ask_for_separate_configuration
    if [ $((diva_uses_separate_configuration)) -eq 0 ]
    then
      $cfg_cmd "$current_card_type SN:$current_card_sn" 0 $((logical_card))  \
                                                                  0 0 1
      group_optimization_cards=4
      group_optimization_card=$((logical_card))
      diva_group_optimization_options
    else
      logical_adapter_to_configure=1
      while [ $((logical_adapter_to_configure)) -le 4 ]
      do
        $cfg_cmd "$current_card_type SN:$current_card_sn" 0 $((logical_card)) \
                                       $((logical_adapter_to_configure)) 0 1
        group_optimization_cards=1
        group_optimization_card=$(($logical_card+$logical_adapter_to_configure-1))
        diva_group_optimization_options
        logical_adapter_to_configure=$(($logical_adapter_to_configure+1))
      done
      echo "" >> $config
    fi
    logical_cards=$(($logical_cards+4))
    b_channels=$(($b_channels+8))
    logical_card=$(($logical_card+4))
    current_card_adapters=4
  ;;

  'diva server voice 4bri-8m pci')
    cfg_cmd="sh $diva_dir/cfg_bri.sh $((current_card)) $diva_dir 8 0"
    diva_ask_for_separate_configuration
    if [ $((diva_uses_separate_configuration)) -eq 0 ]
    then
      $cfg_cmd "$current_card_type SN:$current_card_sn" 0 $((logical_card)) \
                                                           0 0 0
      group_optimization_cards=4
      group_optimization_card=$((logical_card))
      diva_group_optimization_options
    else
      logical_adapter_to_configure=1
      while [ $((logical_adapter_to_configure)) -le 4 ]
      do
        $cfg_cmd "$current_card_type SN:$current_card_sn" 0 $((logical_card)) \
                                       $((logical_adapter_to_configure)) 0 0
        group_optimization_cards=1
        group_optimization_card=$(($logical_card+$logical_adapter_to_configure-1))
        diva_group_optimization_options
        logical_adapter_to_configure=$(($logical_adapter_to_configure+1))
      done
      echo "" >> $config
    fi
    logical_cards=$(($logical_cards+4))
    b_channels=$(($b_channels+8))
    logical_card=$(($logical_card+4))
    current_card_adapters=4
  ;;

  'diva server 4bri-8m pci')
    cfg_cmd="sh $diva_dir/cfg_bri.sh $((current_card)) $diva_dir 8 0"
    diva_ask_for_separate_configuration
    if [ $((diva_uses_separate_configuration)) -eq 0 ]
    then
      $cfg_cmd "$current_card_type SN:$current_card_sn" 0 $((logical_card)) \
                                                         0 0 0
      group_optimization_cards=4
      group_optimization_card=$((logical_card))
      diva_group_optimization_options
    else
      logical_adapter_to_configure=1
      while [ $((logical_adapter_to_configure)) -le 4 ]
      do
        $cfg_cmd "$current_card_type SN:$current_card_sn" 0 $((logical_card)) \
                                  $((logical_adapter_to_configure)) 0 0
        group_optimization_cards=1
        group_optimization_card=$(($logical_card+$logical_adapter_to_configure-1))
        diva_group_optimization_options
        logical_adapter_to_configure=$(($logical_adapter_to_configure+1))
      done
      echo "" >> $config
    fi
    logical_cards=$(($logical_cards+4))
    b_channels=$(($b_channels+8))
    logical_card=$(($logical_card+4))
    current_card_adapters=4
  ;;

  'diva server bri-2m pci')
    cfg_cmd="sh $diva_dir/cfg_bri.sh $((current_card)) $diva_dir 2 0"
    $cfg_cmd "$current_card_type SN:$current_card_sn" 0 $((logical_card)) \
                                          0 1 0
    group_optimization_cards=1
    group_optimization_card=$((logical_card))
    diva_group_optimization_options
    logical_cards=$(($logical_cards+1))
    b_channels=$(($b_channels+2))
    logical_card=$(($logical_card+1))
  ;;

  'diva server bri-2m 2.0 pci')
    cfg_cmd="sh $diva_dir/cfg_bri.sh $((current_card)) $diva_dir 2 0"
    $cfg_cmd "$current_card_type SN:$current_card_sn" 0 $((logical_card)) \
                                          0 0 1
    group_optimization_cards=1
    group_optimization_card=$((logical_card))
    diva_group_optimization_options
    logical_cards=$(($logical_cards+1))
    b_channels=$(($b_channels+2))
    logical_card=$(($logical_card+1))
  ;;

  'diva server voice bri-2m 2.0 pci')
    cfg_cmd="sh $diva_dir/cfg_bri.sh $((current_card)) $diva_dir 2 0"
    $cfg_cmd "$current_card_type SN:$current_card_sn" 0 $((logical_card)) \
                                          0 0 1
    group_optimization_cards=1
    group_optimization_card=$((logical_card))
    diva_group_optimization_options
    logical_cards=$(($logical_cards+1))
    b_channels=$(($b_channels+2))
    logical_card=$(($logical_card+1))
  ;;

  'diva server 2fx')
    cfg_cmd="sh $diva_dir/cfg_bri.sh $((current_card)) $diva_dir 2 0"
    $cfg_cmd "$current_card_type SN:$current_card_sn" 0 $((logical_card)) \
                                          0 0 0
    group_optimization_cards=1
    group_optimization_card=$((logical_card))
    diva_group_optimization_options
    logical_cards=$(($logical_cards+1))
    b_channels=$(($b_channels+2))
    logical_card=$(($logical_card+1))
  ;;

  'diva server pri-30m pci')
    cfg_cmd="sh $diva_dir/cfg_pri.sh $((logical_card)) $diva_dir"
    $cfg_cmd "$current_card_type SN:$current_card_sn"
    group_optimization_cards=1
    group_optimization_card=$((logical_card))
    diva_group_optimization_options
    logical_cards=$(($logical_cards+1))
    b_channels=$(($b_channels+30))
    logical_card=$(($logical_card+1))
  ;;

  'diva server pri 2.0 pci')
    cfg_cmd="sh $diva_dir/cfg_pri.sh $((logical_card)) $diva_dir"
    $cfg_cmd "$current_card_type SN:$current_card_sn"
    group_optimization_cards=1
    group_optimization_card=$((logical_card))
    diva_group_optimization_options
    logical_cards=$(($logical_cards+1))
    b_channels=$(($b_channels+30))
    logical_card=$(($logical_card+1))
  ;;

  'diva server voice pri 2.0 pci')
    cfg_cmd="sh $diva_dir/cfg_pri.sh $((logical_card)) $diva_dir"
    $cfg_cmd "$current_card_type SN:$current_card_sn"
    group_optimization_cards=1
    group_optimization_card=$((logical_card))
    diva_group_optimization_options
    logical_cards=$(($logical_cards+1))
    b_channels=$(($b_channels+30))
    logical_card=$(($logical_card+1))
  ;;

  
  *) rm -f $config
     rm -f $diva_dir/diva_capi_group_optimization_file
     rm -f $diva_dir/diva_capi_dynamic_l1_file
     unload_xdi_driver
     diva_print_unknown_card
     exit 1
   ;;
esac

echo 'if [ $(($?)) -ne 0  ]' >> $config
echo 'then'                  >> $config
echo diva_print_abort        >> $config
echo $diva_dir/divas_stop.rc >> $config
echo 'exit 1'                >> $config
echo 'fi'                    >> $config

echo '# Flush XLOG buffer'   >> $config
while [ $(($current_card_adapters)) -ge 1 ]
do

echo "echo $current_card_type SN:$current_card_sn  > $diva_log$current_logic_adapter.log"                    >> $config
echo "date  >> $diva_log$current_logic_adapter.log" >> $config
echo "$divaload -c $current_logic_adapter -FlushXlog >> $diva_log$current_logic_adapter.log"        >> $config

current_card_adapters=$(($current_card_adapters-1))
current_logic_adapter=$(($current_logic_adapter+1))
done
echo ""                      >> $config

current_card=$(($current_card+1))
done
echo ""                      >> $config

unload_xdi_driver

echo '# --------------------------------------------------------------------' \
                                                                     >> $config
echo '#  CAPI GROP OPTIMIZATION'                                     >> $config
echo '# --------------------------------------------------------------------' \
                                                                     >> $config
if [ -s $diva_dir/diva_capi_group_optimization_file ]
then
cat $diva_dir/diva_capi_group_optimization_file >> $config
fi
echo "" >> $config
echo '# --------------------------------------------------------------------' \
                                                                     >> $config
echo '#  CAPI DYNAMIC L1'                                            >> $config
echo '# --------------------------------------------------------------------' \
                                                                     >> $config
if [ -s $diva_dir/diva_capi_dynamic_l1_file ]
then
cat $diva_dir/diva_capi_dynamic_l1_file >> $config
fi
rm -f $diva_dir/diva_capi_group_optimization_file
rm -f $diva_dir/diva_capi_dynamic_l1_file
echo '# --------------------------------------------------------------------' \
                                                                     >> $config
echo "" >> $config

# ---------------------------------------------------------------------
# Configure passive card
# ---------------------------------------------------------------------
if [ $((passive_card_found)) -ne 0 ]
then
logical_cards=$(($logical_cards+1))
b_channels=$(($b_channels+2))
echo "echo -e \"Start adapter Nr:$((logical_cards)) - '$passive_card_name' ... \c\"" >> $config
cfg_cmd="sh $diva_dir/cfg_bri.sh $((current_card)) $diva_dir 2 1"
$cfg_cmd "$passive_card_name" $passive_card_id $((logical_cards)) 0 0
echo "loaded=\$(lsmod | grep -w DivasC | wc -l | sed -e 's/^ *//' -)" \
                                                            >> $config
echo 'if [ $((loaded)) -eq 0 ]'                             >> $config
echo 'then'                                                 >> $config
echo diva_print_abort                                       >> $config
echo $diva_dir/divas_stop.rc                                >> $config
echo 'exit 1'                                               >> $config
echo 'fi'                                                   >> $config
echo 'echo OK'                                              >> $config
echo ""                                                     >> $config
fi

# ---------------------------------------------------------------------
# Ask for global FAX CLASS 2 options
# ---------------------------------------------------------------------
diva_global_fax_options

# ---------------------------------------------------------------------
# Create suffix
# ---------------------------------------------------------------------
echo "# Load interface drivers"                             >> $config
echo "echo -e \"Load DIVA CAPI2.0 driver ... \c\""          >> $config
if [ $((divas4linux)) -eq 1 ]
then
  if [ -f ${driver_path}capiutil.o ]
  then
    echo "insmod -f ${driver_path}capiutil.o"              >> $config
  fi
  echo "insmod -f ${driver_path}kernelcapi.o"              >> $config
  echo "insmod -f ${driver_path}divacapi.o"                >> $config
  echo "insmod -f ${driver_path}capi.o"                    >> $config
else
echo "modprobe divacapi"                                   >> $config
echo "modprobe capi >/dev/null 2&>1"                       >> $config
fi
echo 'echo OK'                                             >> $config

if [ -f $diva_dir/Divatty.o ]
then
echo "echo -e \"Load DIVA TTY driver ... \c\""              >> $config
if [ $((global_fax_class_2_options)) -ne 0 ]
then
echo "insmod -f $diva_dir/Divatty.o global_options=$((global_fax_class_2_options))" >> $config
else
echo "insmod -f $diva_dir/Divatty.o"                        >> $config
fi
echo 'echo OK'                                              >> $config
fi
echo ""                                                     >> $config

# ---------------------------------------------------------------------
# Create device nodes
# ---------------------------------------------------------------------
#create_interface_nodes

# ---------------------------------------------------------------------
#  FINAL: make script executable
# ---------------------------------------------------------------------
chmod 744 $config
sync

# --------------------------------------------------------------------------
#  INDICATE END OF CONFIGURATION
# --------------------------------------------------------------------------
while [ $view_configuration -eq 2 ]
do
clear
echo ' -------------------------------------------------------------------------------'
echo ' DIVA ADAPTER CONFIGURATION COMPLETE'
echo " Startup script file: $config"
echo ' -------------------------------------------------------------------------------'
echo
echo ' Generated device nodes :'
echo "  /dev/capi20           : MAJOR 68 MINOR 0"
echo '                          Used by CAPI2.0 applications.'
if [ -f $diva_dir/Divatty.o ]
then
echo "  /dev/ttyds[1-$((b_channels))]       : MAJOR   $((diva_tty_major)) MINOR [1-$((b_channels))]"
echo '                          DIVA TTY device with data/fax modem emulation and'
echo "                          extended features (caller ID support,"
echo '                          automatic detection of B-channel protocol,'
echo '                          SYNC PPP support, ASYNC PPP support,'
echo '                          automatic detection of PPP framing type,'
echo '                          automatic ASYNC/SYNC PPP conversion'
echo '                          All TTY features can be controlled by AT commands.'
fi
echo ""
echo " proc FS directory      : $eicon_proc"
echo "                          Access to driver/card trace/status information and"
echo "                          to IDI/Management interface."
echo ' -------------------------------------------------------------------------------'
echo -e " View generated configuration file (Y/N)[N]: \c"
read view_configuration
if [ -z $view_configuration ]
then
view_configuration="N"
fi
case $view_configuration in
 Y) view_configuration=1
  ;;
 y) view_configuration=1
  ;;
 N) view_configuration=0
  ;;
 n) view_configuration=0
  ;;
 *) view_configuration=2
  ;;
esac
done

if [ $view_configuration -eq 1 ]
then
clear
cat $config | more
fi
echo

# ------------------------------------------------------------------------------
#                      END OF CONFIGURATION SCRIPT
# ------------------------------------------------------------------------------

