#! /bin/sh

# ----------------------------------------------------------------------------
#
#              Eicon DIVA ISDN Adapter installation
#
#       Copiright 1993-2001 by Eicon Networks
#
# ----------------------------------------------------------------------------

diva_link_name="03DIVAS4LINUX"
diva_suse_dir="/sbin/init.d/rc"
diva_suse71_dir="/etc/init.d/rc"
diva_rh_dir="/etc/rc.d/rc"
diva_current_link="none"
diva_current_dir="none"
diva_error=0

divas_greeting()
{
echo
echo '+------------------------------------------------------------------------------+'
echo '|                      DIVAS4LINUX INSTALLATION COMPLETE                       |'
echo '+------------------------------------------------------------------------------+'
echo '|                                                                              |'
echo '|                 Please start Eicon DIVA Configuration Wizard                 |'
echo '|                     (/usr/lib/eicon/divas/Config)                            |'
echo '|      in order to detect/configure all installed Eicon DIVA ISDN Adapters     |'
echo '|                                      -                                       |'
echo '|                          Please execute the command                          |'
echo '|                        rpm -q -a -d | grep divas4linux                       |'
echo '|                        to locate package documentation                       |'
echo '|                                                                              |'
echo '+------------------------------------------------------------------------------+'
echo
}

# ------------------------------------------------------------------------------
#
#  Remove All links created at install step
#
# ------------------------------------------------------------------------------
divas_remove_link()
{
if [ -L $diva_current_link ]
then
  rm -f $diva_current_link
fi
if [ -L $diva_current_link ]
then
echo ERROR: Can not remove $diva_current_link
diva_error=1
fi
}

divas_remove_links()
{
#
# SuSE
#
diva_current_link="$diva_suse_dir"2.d/S"$diva_link_name"
divas_remove_link
diva_current_link="$diva_suse_dir"2.d/K"$diva_link_name"
divas_remove_link
diva_current_link="$diva_suse_dir"3.d/S"$diva_link_name"
divas_remove_link
diva_current_link="$diva_suse_dir"3.d/K"$diva_link_name"
divas_remove_link
diva_current_link="$diva_suse_dir"5.d/S"$diva_link_name"
divas_remove_link
diva_current_link="$diva_suse_dir"5.d/K"$diva_link_name"
divas_remove_link
#
# SuSE 7.1
#
diva_current_link="$diva_suse71_dir"2.d/S"$diva_link_name"
divas_remove_link
diva_current_link="$diva_suse71_dir"2.d/K"$diva_link_name"
divas_remove_link
diva_current_link="$diva_suse71_dir"3.d/S"$diva_link_name"
divas_remove_link
diva_current_link="$diva_suse71_dir"3.d/K"$diva_link_name"
divas_remove_link
diva_current_link="$diva_suse71_dir"5.d/S"$diva_link_name"
divas_remove_link
diva_current_link="$diva_suse71_dir"5.d/K"$diva_link_name"
divas_remove_link
#
# RH
#
diva_current_link="$diva_rh_dir"2.d/S"$diva_link_name"
divas_remove_link
diva_current_link="$diva_rh_dir"2.d/K"$diva_link_name"
divas_remove_link
diva_current_link="$diva_rh_dir"3.d/S"$diva_link_name"
divas_remove_link
diva_current_link="$diva_rh_dir"3.d/K"$diva_link_name"
divas_remove_link
diva_current_link="$diva_rh_dir"5.d/S"$diva_link_name"
divas_remove_link
diva_current_link="$diva_rh_dir"5.d/K"$diva_link_name"
divas_remove_link
}

view_link()
{
return 0
}

divas_install_link()
{
if [ -d $diva_current_dir ]
then

ln -s /usr/lib/eicon/divas/divas_cfg.rc $diva_current_link
if [ -L $diva_current_link ]
then
view_link
else
diva_error=1
exit 1
fi

fi
}

divas_install_links()
{
#
# Remove first older links
#
divas_remove_links
case $diva_error in
  0)
   ;;
  *) echo
     echo "ERROR: Installation abortet. Please remove older links first"
     exit 1
   ;;
esac
#
# SuSE
#
echo
echo
if [ -d /sbin/init.d ]
then
diva_current_dir="$diva_suse_dir"2.d
diva_current_link="$diva_current_dir"/S"$diva_link_name"
divas_install_link
diva_current_dir="$diva_suse_dir"3.d
diva_current_link="$diva_current_dir"/S"$diva_link_name"
divas_install_link
diva_current_dir="$diva_suse_dir"5.d
diva_current_link="$diva_current_dir"/S"$diva_link_name"
divas_install_link
fi
#
# SuSE 7.1
#
if [ -d /etc/init.d ]
then
diva_current_dir="$diva_suse71_dir"2.d
diva_current_link="$diva_current_dir"/S"$diva_link_name"
divas_install_link
diva_current_dir="$diva_suse71_dir"3.d
diva_current_link="$diva_current_dir"/S"$diva_link_name"
divas_install_link
diva_current_dir="$diva_suse71_dir"5.d
diva_current_link="$diva_current_dir"/S"$diva_link_name"
divas_install_link
fi
#
# RH
#
if [ ! -L /etc/rc.d ]
then
if [ -d /etc/rc.d ]
then
diva_current_dir="$diva_rh_dir"2.d
diva_current_link="$diva_current_dir"/S"$diva_link_name"
divas_install_link
diva_current_dir="$diva_rh_dir"3.d
diva_current_link="$diva_current_dir"/S"$diva_link_name"
divas_install_link
diva_current_dir="$diva_rh_dir"5.d
diva_current_link="$diva_current_dir"/S"$diva_link_name"
divas_install_link
fi
fi
}

case $1 in
  1) divas_install_links
     divas_greeting
   ;;
  2) divas_remove_links
   ;;
  *) diva_error=1
   ;;
esac

case $diva_error in
  0) exit 0
   ;;
  *) exit 1
   ;;
esac

