#! /bin/sh

# ------------------------------------------------------------------------------
#
#  PRODUCT: divas4linux
#  FILE   : divas_sys_info.sh
#
#  Used to write system information in file report.txt
#
#  Copyright 1991-2000 by Eicon Networks
#
# ------------------------------------------------------------------------------
echo
echo "Output file: report.txt"
echo
echo -n "Processing: "
echo -n "id, "
echo START: check euid              > report.txt 2>&1
id                                 >> report.txt 2>&1
echo -n "pwd, "
echo NEXT: pwd                     >> report.txt 2>&1
pwd                                >> report.txt 2>&1
echo NEXT: check rpm               >> report.txt 2>&1
echo -n "rpm, "
rpm -q -a | grep -i divas4linux    >> report.txt 2>&1
echo NEXT: /proc/cpuinfo        >> report.txt 2>&1
echo -n "/proc/cpuinfo, "
cat /proc/cpuinfo               >> report.txt 2>&1
echo NEXT: /proc/ioports        >> report.txt 2>&1
echo -n "/proc/ioiports, "
cat /proc/ioports               >> report.txt 2>&1
echo NEXT: /proc/interrupts        >> report.txt 2>&1
echo -n "/proc/interrupts, "
cat /proc/interrupts               >> report.txt 2>&1
echo NEXT: /proc/meminfo           >> report.txt 2>&1
echo -n "/proc/meminfo, "
cat /proc/meminfo                  >> report.txt 2>&1
echo NEXT: /proc/pci               >> report.txt 2>&1
echo -n "/proc/pci, "
cat /proc/pci                      >> report.txt 2>&1
echo NEXT: /proc/bus/pci/devices   >> report.txt 2>&1
echo -n "/proc/bus/pci/devices, "
cat /proc/bus/pci/devices          >> report.txt 2>&1
echo NEXT: /proc/version           >> report.txt 2>&1
echo -n "/proc/version, "
cat /proc/version                  >> report.txt 2>&1
echo NEXT: uname -a                >> report.txt 2>&1
echo -n "uname -a, "
uname -a                           >> report.txt 2>&1
echo NEXT: check module load       >> report.txt 2>&1
echo -n "lsmod, "
lsmod                              >> report.txt 2>&1
echo -n "/proc/modules, "
cat /proc/modules                  >> report.txt 2>&1
echo -n "/proc/devices, "
cat /proc/devices                  >> report.txt 2>&1
echo NEXT: check device nodes      >> report.txt 2>&1
echo -n "/dev, "
ls -l /dev/capi20                  >> report.txt 2>&1
ls -l /dev/ttyds*                  >> report.txt 2>&1
echo NEXT: Check printk            >> report.txt 2>&1
echo -n "/proc/ksyms, "
cat /proc/ksyms | grep printk      >> report.txt 2>&1
echo NEXT: Check diddXXX           >> report.txt 2>&1
cat /proc/ksyms | grep -i didd     >> report.txt 2>&1
echo NEXT: Check divaXXX           >> report.txt 2>&1
cat /proc/ksyms | grep -i diva     >> report.txt 2>&1
echo NEXT: Check pciXXX            >> report.txt 2>&1
cat /proc/ksyms | grep -i pci      >> report.txt 2>&1
echo NEXT: check versions             >> report.txt 2>&1
echo -n "ls -l, "
ls -l                                 >> report.txt 2>&1
echo -n "builds, "
echo divadidd.o                       >> report.txt 2>&1
strings divadidd.o | grep "10[0-9]-"  >> report.txt 2>&1
echo divas.o                          >> report.txt 2>&1
strings divas.o    | grep "10[0-9]-"  >> report.txt 2>&1
echo diva_mnt.o                       >> report.txt 2>&1
strings diva_mnt.o | grep "10[0-9]-"  >> report.txt 2>&1
echo diva_idi.o                       >> report.txt 2>&1
strings diva_idi.o | grep "10[0-9]-"  >> report.txt 2>&1
echo divacapi.o                       >> report.txt 2>&1
strings divacapi.o | grep "10[0-9]-"  >> report.txt 2>&1
if [ -f DivasC.o ]
then
echo DivasC.o                         >> report.txt 2>&1
strings DivasC.o   | grep "10[0-9].-" >> report.txt 2>&1
fi
if [ -f DivasC6.o ]
then
echo DivasC6.o                        >> report.txt 2>&1
strings DivasC6.o | grep "10[0-9].-"  >> report.txt 2>&1
fi
if [ -f Divatty.o ]
then
echo Divatty.o                        >> report.txt 2>&1
strings Divatty.o | grep "10[0-9]-"   >> report.txt 2>&1
fi
if [ -f divactrl ]
then
echo divactrl                         >> report.txt 2>&1
strings divactrl | grep "10[0-9]-"    >> report.txt 2>&1
fi
if [ -f /sbin/divactrl ]
then
echo /sbin/divactrl                      >> report.txt 2>&1
strings /sbin/divactrl | grep "10[0-9]-" >> report.txt 2>&1
fi
echo dspdload.bin                  >> report.txt 2>&1
strings dspdload.bin | grep "10[0-9]-" >> report.txt 2>&1
echo ds4bri.bit                    >> report.txt 2>&1
strings ds4bri.bit   | grep "10[0-9]-" >> report.txt 2>&1
echo ds4bri2.bit                    >> report.txt 2>&1
strings ds4bri2.bit   | grep "10[0-9]-" >> report.txt 2>&1
echo pri_files:                    >> report.txt 2>&1
strings *.pm         | grep "10[0-9]-" >> report.txt 2>&1
echo pri_v2_files:                 >> report.txt 2>&1
strings *.pm2        | grep "10[0-9]-" >> report.txt 2>&1
echo bri_files:                    >> report.txt 2>&1
strings *.sm         | grep "10[0-9]-" >> report.txt 2>&1
echo bri4_files:                   >> report.txt 2>&1
strings *.sm.4       | grep "10[0-9]-" >> report.txt 2>&1
echo qbri_files:                   >> report.txt 2>&1
strings *.qm?        | grep "10[0-9]-" >> report.txt 2>&1
echo qbri_v2_files:                   >> report.txt 2>&1
strings *.2q?        | grep "10[0-9]-" >> report.txt 2>&1
echo NEXT: sums                    >> report.txt 2>&1
echo -n "sum *, "
find .  ! -name "KLOG*" -maxdepth 1 -print | xargs sum >> report.txt 2>&1
echo NEXT: dump curtent config     >> report.txt 2>&1
echo -n "diva_cfg.rc, "
cat divas_cfg.rc                   >> report.txt 2>&1
echo NEXT: check links             >> report.txt 2>&1
echo -n "links, "
ls -l /sbin/init.d/rc2.d/S03DIVAS4LINUX >> report.txt 2>&1
ls -l /sbin/init.d/rc3.d/S03DIVAS4LINUX >> report.txt 2>&1
ls -l /sbin/init.d/rc5.d/S03DIVAS4LINUX >> report.txt 2>&1
ls -l /etc/rc.d/rc2.d/S03DIVAS4LINUX    >> report.txt 2>&1
ls -l /etc/rc.d/rc3.d/S03DIVAS4LINUX    >> report.txt 2>&1
ls -l /etc/rc.d/rc5.d/S03DIVAS4LINUX    >> report.txt 2>&1
echo NEXT: process /var/log/messages    >> report.txt 2>&1
echo -n "/var/log/messages, "
grep -i DIVA  /var/log/messages         >> report.txt 2>&1
grep -i EICON /var/log/messages         >> report.txt 2>&1
echo NEXT: look for klogd               >> report.txt 2>&1
echo -n "klogd parameters, "
ps ax | grep klogd                      >> report.txt 2>&1
echo NEXT: /proc/tty/drivers            >> report.txt 2>&1
echo -n "/proc/tty/drivers, "
cat /proc/tty/drivers                   >> report.txt 2>&1
echo NEXT: /var/log/diva*.log           >> report.txt 2>&1
echo -n "xlog, "
if [ -f /var/log/diva1.log ]
then
cat /var/log/diva*.log                  >> report.txt 2>&1
else
echo "no xlog found"                    >> report.txt 2>&1
fi
echo END                                >> report.txt 2>&1
echo -n "END"
echo
echo
sync

# ------------------------------------------------------------------------------
#   END
# ------------------------------------------------------------------------------

